#! usr/bin/perl

use strict;
use warnings;
use List::Util qw(sum);

sub mean {
	if(@_) {
		return sum(@_)/@_;
	}
}


open IN, '<', $ARGV[0] or die "Cannot open $ARGV[0] \n";
open OUT, '>', $ARGV[1] or die "Cannot open outfile $ARGV[1]\n";

my @xvals;
my @yvals;
my @zvals;
my @MSD;

while(<IN>) {
	chomp;
	my @line = split /,/, $_;
	if ($line[1]!~"Mean x coord") {
		push @xvals, $line[1];
	}
	if ($line[2]!~"Mean y coord") {
		push @yvals, $line[2];
	}
	if ($line[3]!~"Mean z coord") {
		push @zvals, $line[3];
	}
}


for (my $x = 1; $x <= (@xvals-1); $x++) {
		my $sub = ($x + 1);
		my @delta_sq;
		for (my $i = 0; $i <= (@xvals-$sub); $i++) {
			my $j = ($i + $x);
			push(@delta_sq, ((($xvals[$i] - $xvals[$j])**2) + (($yvals[$i] - $yvals[$j])**2) + ((($zvals[$i] - $zvals[$j])**2))));
		}
	push(@MSD, &mean(@delta_sq));  
	}

for(my $i=0;$i<=(@MSD-1);$i++){
		print OUT "$MSD[$i]\n";
	}


close IN;
close OUT;
